/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package jdbcadressbuch;

import java.io.OutputStream;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author micha
 */
public class JdbcAdressbuch {

    boolean loop = true;
    java.sql.Connection dbVerbindung;
    PreparedStatement prepStmnt;
    ResultSet resSet;

    String nachname;
    String vorname;
    String emaille;
    
    JdbcAdressbuch() {
        System.out.print(String.format("\033[H\033[2J"));
        this.druckeMenue();
        while (loop) {
            int choice = new Scanner(System.in).nextInt();
            switch (choice) {
                case 1:
                    suchePerson();
                    break;
                case 2:
                    sucheAdresse();
                    break;
                case 3:
                    loescheEintrag();
                    break;
                case 4:
                    hinzuKontakt();
                    break;
                case 5:
                    aendernAdresse();
                    break;
                case 6:
                    loescheAdresse();
                    break;
                case 7:
                    endeUndAus();
            }
        }
    }

    void druckeMenue() {
        System.out.printf("(1) nach Personen suchen\t"
                + "(2) nach Adressen suchen\t"
                + "(3) Eintrag loeschen\n");
        System.out.printf("(4) Kontakte hinzufuegen\t"
                + "(5) E-Mail-Adressen aendern\t"
                + "(6) E-Mail-Adressen loeschen\n");
        System.out.printf("(7) fertig Spass!\n");
    }

    void suchePerson() {
        System.out.printf("Suchmuster?");
        String muster = new Scanner(System.in).next();
        System.out.print(String.format("\033[H\033[2J"));
        try {
            // connection zur emaille-db erzeugen
            Connection conn = new DbConnection().getVerbindung();

            //preparedStatement fuer namens- und vornamens-suche bauen
            prepStmnt = conn.prepareStatement(
                    "select id, nname, vname, emaille"
                    + " from person join emaille "
                    + " ON person.id = emaille.person"
                    + " where nname like ? OR vname like ?"
            );
            prepStmnt.setString(1, "%" + muster + "%");
            prepStmnt.setString(2, "%" + muster + "%");
            resSet = prepStmnt.executeQuery();

            this.printResultsTable(resSet, System.out);
            /*
            while (resSet.next()) {
                System.out.printf("%s\t",resSet.getInt("id"));
                System.out.printf("%s\t",resSet.getString("nname"));
                System.out.printf("%s\t",resSet.getString("vname"));
            }
             */
            this.druckeMenue();
        } catch (SQLException ex) {
            ex.printStackTrace();
        }

    }

    void sucheAdresse() {
    }

    void loescheEintrag() {
    }

    void hinzuKontakt() {
    
        while(true){
            System.out.printf("Eingabe: Nachname SP Vorname SP Email-Adresse:");
            Scanner scanner = new Scanner(System.in);
            nachname = scanner.next();
            vorname = scanner.next();
            emaille = scanner.next();
            
            System.out.print(String.format("\033[H\033[2J"));
            
            System.out.printf("In die Datenbank wird eingetragen: %s, %s, %s\n", nachname, vorname, emaille);
            System.out.println("Ist das korrekt? j=ja, n=nein, x=abbruch");
            String vali = new Scanner(System.in).next();
            if (vali.equalsIgnoreCase("j")) {
                druckeMenue();
                System.out.println("jetzt wirds ernst!!!!!!!!!!!!!!!!");
                break;
            }
            if (vali.equalsIgnoreCase("x")) {
                druckeMenue();
                System.out.println("nix passiert");
                break;
            }
        }
    }
        
   
    void aendernAdresse() {
    }

    void loescheAdresse() {
    }

    void endeUndAus() {
        System.exit(0);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new JdbcAdressbuch();// TODO code application logic here
    }

    //##############################
    /**
     * This method attempts to output the contents of a ResultSet in a textual
     * table. It relies on the ResultSetMetaData class, but a fair bit of the
     * code is simple string manipulation.
     *
     */
    void printResultsTable(ResultSet rs, OutputStream output)
            throws SQLException {
        // Set up the output stream
        PrintWriter out = new PrintWriter(output);

        // Get some "meta data" (column names, etc.) about the results
        ResultSetMetaData metadata = rs.getMetaData();

        // Variables to hold important data about the table to be displayed
        int numcols = metadata.getColumnCount(); // how many columns
        String[] labels = new String[numcols];   // the column labels
        int[] colwidths = new int[numcols];      // the width of each
        int[] colpos = new int[numcols];         // start position of each
        int linewidth;                           // total width of table

        // Figure out how wide the columns are, where each one begins, 
        // how wide each row of the table will be, etc.
        linewidth = 1; // for the initial '|'.
        for (int i = 0; i < numcols; i++) {             // for each column
            colpos[i] = linewidth;                     // save its position
            labels[i] = metadata.getColumnLabel(i + 1);  // get its label 
            // Get the column width.  If the db doesn't report one, guess
            // 30 characters.  Then check the length of the label, and use
            // it if it is larger than the column width
            int size = metadata.getColumnDisplaySize(i + 1);
            if (size == -1) {
                size = 30;  // Some drivers return -1...
            }
            if (size > 500) {
                size = 30;  // Don't allow unreasonable sizes
            }
            int labelsize = labels[i].length();
            if (labelsize > size) {
                size = labelsize;
            }
            colwidths[i] = size + 1;              // save the column the size  
            linewidth += colwidths[i] + 2;        // increment total size
        }

        // Create a horizontal divider line we use in the table.
        // Also create a blank line that is the initial value of each 
        // line of the table
        StringBuffer divider = new StringBuffer(linewidth);
        StringBuffer blankline = new StringBuffer(linewidth);
        for (int i = 0; i < linewidth; i++) {
            divider.insert(i, '-');
            blankline.insert(i, " ");
        }
        // Put special marks in the divider line at the column positions
        for (int i = 0; i < numcols; i++) {
            divider.setCharAt(colpos[i] - 1, '+');
        }
        divider.setCharAt(linewidth - 1, '+');

        // Begin the table output with a divider line
        out.println(divider);

        // The next line of the table contains the column labels.
        // Begin with a blank line, and put the column names and column
        // divider characters "|" into it.  overwrite() is defined below.
        StringBuffer line = new StringBuffer(blankline.toString());
        line.setCharAt(0, '|');
        for (int i = 0; i < numcols; i++) {
            int pos = colpos[i] + 1 + (colwidths[i] - labels[i].length()) / 2;
            overwrite(line, pos, labels[i]);
            overwrite(line, colpos[i] + colwidths[i], " |");
        }

        // Then output the line of column labels and another divider
        out.println(line);
        out.println(divider);

        // Now, output the table data.  Loop through the ResultSet, using
        // the next() method to get the rows one at a time. Obtain the 
        // value of each column with getObject(), and output it, much as 
        // we did for the column labels above.
        while (rs.next()) {
            line = new StringBuffer(blankline.toString());
            line.setCharAt(0, '|');
            for (int i = 0; i < numcols; i++) {
                Object value = rs.getObject(i + 1);
                if (value != null) {
                    overwrite(line, colpos[i] + 1, value.toString().trim());
                }
                overwrite(line, colpos[i] + colwidths[i], " |");
            }
            out.println(line);
        }

        // Finally, end the table with one last divider line.
        out.println(divider);
        out.flush();
    }

    /**
     * This utility method is used when printing the table of results
     */
    void overwrite(StringBuffer b, int pos, String s) {
        int slen = s.length();                 // string length
        int blen = b.length();                 // buffer length
        if (pos + slen > blen) {
            slen = blen - pos;  // does it fit?
        }
        for (int i = 0; i < slen; i++) // copy string into buffer
        {
            b.setCharAt(pos + i, s.charAt(i));
        }
    }

}
